﻿using System.Windows.Forms;
using CustomControl.Tree;

namespace Demo
{
    public class ComboTreeViewOrganization : ComboTreeView<Organization>
    {
        public ComboTreeViewOrganization() : base(new TreeView())
        {
        }

        public ComboTreeViewOrganization(TreeView internalTreeView) : base(internalTreeView)
        {
        }

        public override Organization GetTreeNodeData(TreeNode node)
        {
            if (null != node)
            {
                return (Organization)node.Tag;
            }
            else
            {
                return null;
            }
        }

        protected override bool Identical(Organization x, Organization y)
        {
            if ((null != x) && (null != y))
            {
                return string.Equals(x.Id, y.Id);
            }
            else if ((null == x) && (null == y))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
