﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.Shown += new EventHandler((sender, e) =>
            {
                this.InitializeData();
                this.InitializeData1();
            });
        }

        private void InitializeData()
        {
            this.comboTreeViewOrganization.DisplayMember = "Name";

            var treeView = this.comboTreeViewOrganization.TreeView;
            var data = this.GetData();
            this.AddTreeNodes(treeView.Nodes, data);
        }

        private void InitializeData1()
        {
            this.comboTreeViewOrganization1.DisplayMember = "Name";

            var treeView = this.comboTreeViewOrganization1.TreeView;
            var data = this.GetData();
            this.AddTreeNodes(treeView.Nodes, data);

            this.comboTreeViewOrganization1.SelectedNodeData = this.CreateOrganization("A1");
        }

        private void AddTreeNodes(TreeNodeCollection nodes, IList<Organization> data)
        {
            if (null != data && data.Count > 0)
            {
                foreach (Organization o in data)
                {
                    var nd = new TreeNode(o.Name);
                    nd.Tag = o;
                    nodes.Add(nd);
                    this.AddTreeNodes(nd.Nodes, o.Suborganizations);
                }
            }
        }

        private IList<Organization> GetData()
        {
            var orgA = this.CreateOrganization("A");
            orgA.Suborganizations = new List<Organization>()
            {
                this.CreateOrganization("A1"),
                this.CreateOrganization("A2"),
                this.CreateOrganization("A3"),
            };

            var orgB = this.CreateOrganization("B");
            orgB.Suborganizations = new List<Organization>()
            {
                this.CreateOrganization("B1"),
                this.CreateOrganization("B2"),
                this.CreateOrganization("B3"),
            };

            var orgC = this.CreateOrganization("C");
            orgC.Suborganizations = new List<Organization>()
            {
                this.CreateOrganization("C1"),
                this.CreateOrganization("C2"),
                this.CreateOrganization("C3"),
            };

            return new List<Organization>() { orgA, orgB, orgC };
        }

        private Organization CreateOrganization(string name)
        {
            return new Organization()
            {
                Id = name.ToLower(),
                Name = name
            };
        }
    }
}
